SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection-Tests'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Misc'!
SystemOrganization addCategory: #'OmniVMNoOpt-Transporter'!

Array variableSubclass: #OstArray
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstArray class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/10/2012 13:41'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!SmalltalkImage methodsFor: '*OmniVMNoOpt-special objects' stamp: 'StefanMarr 3/19/2012 14:32'!
recreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 100.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray at: 31 put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: 0@0.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes (yeah, right)"
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 36 put: (self specialObjectsArray at: 36). "Is the prototype MethodContext (unused by the VM)"
	newArray at: 37 put: BlockClosure.
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 38 put: (self specialObjectsArray at: 38). "Is the prototype BlockContext (unused by the VM)"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"preserve external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: nil. "Reserved for a LinkedList instance for overlapped calls in CogMT"
	"finalization Semaphore"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	"newArray at: 51 put: #attemptToAssign:withIndex:."
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallback:stack:registers:jmpbuf:.
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Weak reference finalization"
	newArray at: 56 put: (self at: #WeakFinalizationList ifAbsent: []).

		"Omni Changes"
	newArray at: 61 put: #readField:of:.
	newArray at: 62 put: #requestExecutionOf:on:.
	newArray at: 63 put: #write:toField:of:.
	
	newArray at: 70 put: OstDomain.
	newArray at: 71 put: ONOMirror OstDomainSelectorArray.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray become: newArray! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 3/19/2012 15:19'!
methodFlag: aBool
	"set the user-level flag bit"
	| old |
	old := self flag.
	aBool
		ifTrue: [ self objectAt: 1 put: (self header bitOr: (1 << 29)) ]
		ifFalse: [self objectAt: 1 put: (self header bitAnd: (1 << 29) bitInvert) ].
	
	^ old! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 3/19/2012 15:45'!
properties: aMethodProperties
	"Set the method-properties of the receiver to aMethodProperties."
	self literalAt: self numLiterals - 1
		put: (aMethodProperties isEmpty
				ifTrue: [aMethodProperties selector]
				ifFalse: [aMethodProperties
							setMethod: self;
							yourself]).
	
	"After setting the properties we need to reconsider the flag"
	(self pragmaAt: #omniMetaExit) ifNotNilDo: [:p | self methodFlag: true].! !

TestCase subclass: #ONOCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 3/10/2012 19:46'!
methodWithOmniMetaExit
	<omniMetaExit>
	^ self! !

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 3/10/2012 19:47'!
methodWithoutAnyPragma
	^ self! !

!ONOCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 19:49'!
testOmniMetaExitMethodFlag
	"IMPORTANT: we assume the code has be already compiled with a suitable compiler"
	
	self assert: (self class >> #methodWithoutAnyPragma) flag not.
	
	self assert: (self class >> #methodWithOmniMetaExit) flag.! !

TestCase subclass: #ONODomainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 10:35'!
helperExecuteAllMessages: o
	self assert: #a equals: o a.
	self assert: #b equals: o b.
	self assert: nil equals: o magicNil.
	self assert: 1 equals: o magicOne.
	self assert: o equals: o magicSelf.
	self assert: 'ab' equals: o ab.
	
	o b: #bb.
	self assert: #bb equals: o b.
	
	o a: #aa.
	self assert: #aa equals: o a. 
	
	o makeOne.
	self assert: 1 equals: o b.! !

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 11/12/2011 21:33'!
helperExecuteAllMessagesSimple: o
	o a.
	o b.
	o magicNil.
	o magicOne.
	o magicSelf.
	o ab.
	o b: #bb.
	o a: #aa.
	o makeOne.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 19:22'!
testAdopt
	| o d |
	o := Object new.
	d := OstDomain new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	
	d adoptObject: o.
	
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 21:56'!
testDomainForNewObjectsInitialization
	| domain |
	domain := ONOTestDomain new.
	self assert: domain equals: domain domainForNewObjects.
	
	self assert: domain equals: (domain instVarNamed: #domainForNewObjects).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:39'!
testReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[self helperExecuteAllMessages: o ] omni: d.

	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 10:28'!
testRequestExecWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors reject: [:sel | sel = #initialize].
	
	[self helperExecuteAllMessages: o ] omni: d.

	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:40'!
testSimpleReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a ] omni: d.

	self assert: 1 equals: d readCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 14:39'!
testSimpleWriteWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a: #bbb ] omni: d.

	self assert: 1 equals: d writeCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/19/2012 15:54'!
testWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors asOrderedCollection reject: [:sel | sel = #initialize].
	expectedSelectors add: #=.
	
	[self helperExecuteAllMessages: o ] omni: d.
	
	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.
	
	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 11/11/2011 00:35'!
testWithNilDomain
	| o |
	o := ONOTestObject new.
	self helperExecuteAllMessages: o.! !

TestCase subclass: #ONOMirrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 3/10/2012 19:51'!
onMetaLevel
	<omniMetaExit>
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 3/10/2012 19:51'!
onSomeLevelNoPragma
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/15/2012 15:14'!
testBaselevelPerform
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:33'!
testBaselevelPerformWithArguments
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #()) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:34'!
testBaselevelPerformWithArgumentsInSuperclass
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #() inSuperclass: self class) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:56'!
testBlockBaseLevel
	| d baseLevel |
	d := OstDomain new.
	
	baseLevel := [ ONOMirror executesOnBaseLevel ] omni: d.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:58'!
testBlockBaseLevelValueWithArgs
	| baseLevel |
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := [:i | ONOMirror executesOnBaseLevel ] value: 1.
	
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:46'!
testMetaExitPragma
	| onBaseLvl1 onBaseLvl2 onMetaLvl |
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: self onMetaLevel.
	
	self assert: self onSomeLevelNoPragma.
	
	ONOMirror switchToBaseLevel.
	
	"We post-pone the asserts to not run into trouble with SUnit and the tests."
	onBaseLvl1 := self onSomeLevelNoPragma not.
	onMetaLvl := self onMetaLevel.
	onBaseLvl2 := self onSomeLevelNoPragma not.
	
	ONOMirror switchToMetaLevel.
	
	self assert: onBaseLvl1.
	self assert: onMetaLvl.
	self assert: onBaseLvl2.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 11:27'!
testOmniBlockThisContext
	| d  execD |
	d := OstDomain new.
	
	execD := [ ONOMirror domainOf: thisContext ] omni: d.
	
	self assert: d equals: execD.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 18:33'!
testPrimitiveGetSetDomain
	| o d |
	o := Object new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	 
	d := Object new.
	ONOMirror setDomainOf: o to: d.
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:49'!
testSwitchExecLevel
	| baseLevel |
	self assert: ONOMirror executesOnMetaLevel.
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := ONOMirror executesOnBaseLevel.
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	self assert: ONOMirror executesOnMetaLevel.! !

!BlockClosure methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/19/2012 14:27'!
omni: aDomain
	"Move to language/baselevel and in the context of the given domain"
	^ aDomain evaluateInContextOnBaseLevel: self! !

Object subclass: #ONOMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!ONOMirror class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2012 18:25'!
OstDomainSelectorArray
	^ OstDomain methodDict keys asSortedCollection asArray! !

!ONOMirror class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2012 18:27'!
OstDomainSelectorIndicesCppClass
	"This method generates the Cpp class we use to access the method symbols"
	| cpp selectors i |
	
	"Make sure that the system dictionary is up to date"
	Smalltalk recreateSpecialObjectsArray.
	
	cpp := 'class OstDomainSelector_Indices {
public:
'.
	selectors := self OstDomainSelectorArray.
	
	i := 0.
	selectors do: [:sel |
		cpp := cpp, '  static const oop_int_t ', (self SymbolForCpp: sel), ' = ', i asString, ';
'.
		i := i + 1.
	].

	cpp := cpp, '
};

'.
	^ cpp! !

!ONOMirror class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/13/2012 15:49'!
SymbolForCpp: aSymbol
	| capitalizeNext |
	capitalizeNext := true.
	^ aSymbol collect: [:c |
		c = $:
			ifTrue: [ capitalizeNext := true. $_ ]
			ifFalse: [
				capitalizeNext
					ifTrue: [ capitalizeNext := false. c asUppercase ]
					ifFalse: [c]
			]
	].! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:31'!
domainOf: anObject
	"Returns the domain object on success"
	<primitive: 'primitiveGetDomain' module: 'OmniPlugin'>
	^ -1! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 19:26'!
executesOnBaseLevel
	<omniMetaExit>
	<primitive: 'primitiveExecutesOnBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 19:26'!
executesOnMetaLevel
	<omniMetaExit>
	<primitive: 'primitiveExecutesOnMetaLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:28'!
setDomainOf: anObject to: aDomain
	"Returns self on success"
	<primitive: 'primitiveSetDomain' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 19:01'!
switchToBaseLevel
	<omniMetaExit>
	<primitive: 'primitiveSwitchToBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 19:02'!
switchToMetaLevel
	<omniMetaExit>
	<primitive: 'primitiveSwitchToMetaLevel' module: 'OmniPlugin'>
	^ nil! !

Object subclass: #ONOTestObject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a
	^ a! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a: anObj
	a := anObj! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 21:22'!
ab
	^ a, b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:46'!
b
	^ b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:48'!
b: anObj
	b := anObj! !

!ONOTestObject methodsFor: 'initialize-release' stamp: 'StefanMarr 11/10/2011 23:45'!
initialize
	a := #a.
	b := #b.! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicNil
	^ nil! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicOne
	^ 1! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicSelf
	^ self! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
makeOne
	b := 1.! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OPromise commentStamp: 'StefanMarr 3/9/2012 21:09' prior: 0!
Provides a simple promise implementation.
A promise is a value that is going to be resolved in the future, typically by an asynchronous computation.
Reading an unresolved promise is a blocking operation.!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 3/11/2012 22:38'!
await
	<omniMetaExit>
	[value = NoValueDelivered] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		"signal waitTimeoutMSecs: 100. only available in Pharo"
		(Delay new setDelay:100 forSemaphore: signal) wait.
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 1/9/2012 17:53'!
deliver: aValue
	<omniMetaExit>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 1/9/2012 17:53'!
read
	<omniMetaExit>
	self await.
	^ value! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: aSymbol 
	"Send the unary selector, aSymbol, to the receiver.
	Fail if the number of arguments expected by the selector is not zero.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array new: 0)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ otherTarget baselevelPerform: selector! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:14'!
baselevelPerform: aSymbol with: anObject 
	"Send the selector, aSymbol, to the receiver with anObject as its argument.
	Fail if the number of arguments expected by the selector is not one.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not two.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/17/2012 12:30'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: p4)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:34'!
baselevelPerform: selector withArguments: argArray 
	"Send the selector, aSymbol, to the receiver with arguments in argArray.
	Fail if the number of arguments expected by the selector 
	does not match the size of argArray.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 186>
	^ self baselevelPerform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:35'!
baselevelPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 187>
	(selector isMemberOf: Symbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*OmniVMNoOpt' stamp: 'StefanMarr 3/19/2012 14:30'!
doesNotUnderstand: aMessage
	<omniMetaExit>
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
		on: MessageNotUnderstood
		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	(exception := MessageNotUnderstood new)
		message: aMessage;
		receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
		ifTrue: [aMessage sentTo: self]
		ifFalse: [resumeValue]! !

Object subclass: #OmniNoOptTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Transporter'!

!OmniNoOptTransporter class methodsFor: 'transporter' stamp: 'StefanMarr 11/10/2011 16:38'!
transportersForFileOutMenu
	^ { Transporter forPackage: (PackageInfo named: 'OmniVMNoOpt') }! !

Object subclass: #OstDomain
	instanceVariableNames: 'domainForNewObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

OstDomain subclass: #ONORWTestDomain
	instanceVariableNames: 'target cntReadA cntReadB cntWriteA cntWriteB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONORWTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 3/14/2012 11:09'!
initialize
	super initialize.
	
	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountA
	^ cntReadA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountB
	^ cntReadB! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/19/2012 22:15'!
readField: idx of: obj
	<omniMetaExit>
	obj == target ifTrue: [
		[Transcript cr; show: 'read field: ', idx asString.].
		
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
target: targetObj
	target := targetObj! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/19/2012 22:15'!
write: val toField: idx of: obj
	<omniMetaExit>
	obj == target ifTrue: [
		[Transcript cr; show: 'write to field: ', idx asString].
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ obj! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountA
	^ cntWriteA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountB
	^ cntWriteB! !

OstDomain subclass: #ONOTestDomain
	instanceVariableNames: 'target requestedSelectors cntReadA cntReadB cntWriteA cntWriteB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 11/12/2011 00:40'!
initialize
	super initialize.
	
	requestedSelectors := Set new.

	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountA
	^ cntReadA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountB
	^ cntReadB! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/20/2012 00:24'!
readField: idx of: obj
	<omniMetaExit>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/14/2012 00:35'!
requestExecution: p1 of: aSelector on: receiver
	<omniMetaExit>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/13/2012 19:29'!
requestExecutionOf: aSelector on: receiver
	<omniMetaExit>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecutionOf: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 23:12'!
requestedSelectors
	^ requestedSelectors! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 22:38'!
target: targetObj
	target := targetObj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/20/2012 00:24'!
write: val toField: idx of: obj
	<omniMetaExit>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ obj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountA
	^ cntWriteA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountB
	^ cntWriteB! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 3/13/2012 18:33'!
currentDomain
	^ ONOMirror domainOf: thisContext! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 3/10/2012 18:32'!
omniDomainFrom: obj
	^ ONOMirror domainOf: obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/10/2012 18:33'!
adoptObject: obj
	ONOMirror setDomainOf: obj to: self.
	^ obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:06'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/13/2012 12:40'!
evaluateInContext: aBlock
	| oldDomain result |
	oldDomain := ONOMirror domainOf: thisContext.
	
	ONOMirror setDomainOf: thisContext to: self.
	
	result := aBlock value.
	
	ONOMirror setDomainOf: thisContext to: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/13/2012 12:39'!
evaluateInContextOnBaseLevel: aBlock
	| oldDomain result |
	
	oldDomain := ONOMirror domainOf: thisContext.
	ONOMirror setDomainOf: thisContext to: self.
	ONOMirror switchToBaseLevel.
	
	result := aBlock value.
	
	ONOMirror switchToMetaLevel.
	ONOMirror setDomainOf: thisContext to: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 3/9/2012 22:10'!
initialize
	super initialize.
	domainForNewObjects := self domainForNewObjects.
	! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/13/2012 18:40'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := Process
		forContext: ctx
		priority: Processor activePriority.

	ONOMirror setDomainOf: ctx to: self.
	^ proc.! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:13'!
primAt: idx on: anObj
	<omniMetaExit>
	^ anObj at: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:13'!
primAt: idx on: anObj put: aVal
	<omniMetaExit>
	^ anObj at: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:13'!
primBasicAt: idx on: anObj
	<omniMetaExit>
	^ anObj basicAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:14'!
primBasicAt: idx on: anObj put: aVal
	<omniMetaExit>
	^ anObj basicAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:14'!
primInstVarAt: idx on: anObj
	<omniMetaExit>
	^ anObj instVarAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/3/2012 16:14'!
primInstVarAt: idx on: anObj put: aVal
	<omniMetaExit>
	^ anObj instVarAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 1/10/2012 11:40'!
primShallowCopy: anObj
	<omniMetaExit>
	^ anObj shallowCopy! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 12/15/2011 15:03'!
readField: idx of: obj
	<omniMetaExit>
	^ obj instVarAt: idx! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 12/9/2011 15:57'!
readGlobal: association
	^ association value! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:14'!
requestExecution: p1 of: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:14'!
requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:14'!
requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:14'!
requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:14'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject 
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:15'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject 
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:15'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:15'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8  of: aSelector on: anObject 
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:15'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9  of: aSelector on: anObject 
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:15'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject 
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:16'!
requestExecutionOf: aSelector lookup: cls on: anObject
	<omniMetaExit>
	^ anObject baselevelPerformSuper: aSelector inLookupClass: cls! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:16'!
requestExecutionOf: aSelector lookup: cls on: anObject with: p1
	<omniMetaExit>
	^ anObject baselevelPerformSuper: aSelector with: { p1 } inLookupClass: cls.! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 3/15/2012 16:16'!
requestExecutionOf: aSelector on: anObject
	<omniMetaExit>
	^ anObject baselevelPerform: aSelector! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:07'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"
	
	self flag: 'WARNING: copied from ODomain.
	TODO: fix later after abstracting concepts from the results of the experiments.'.
	
	^ (self newProcessFor: aBlock) resume! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 12/15/2011 15:02'!
write: val toField: idx of: obj
	<omniMetaExit>
	^ obj instVarAt: idx put: val.! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 12/9/2011 15:57'!
writeGlobal: association value: val
	^ association value: val! !

Object subclass: #OstObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 3/9/2012 21:08' prior: 0!
This is a compatibility class with the same name as what I got in the bytecode transformation-based implementation.!
OPromise initialize!
